Crypto++ 8.9 Free C++ class library of cryptographic schemes

Public Member Functions | Static Public Member Functions | List of all members
SipHash_Base< C, D, T_128bit > Class Template Reference

SipHash message authentication code base class. More...

Inheritance diagram for SipHash_Base< C, D, T_128bit >:

## Public Member Functions
virtual unsigned int | DigestSize () const
| Provides the digest size of the hash. More...
virtual size_t | MinKeyLength () const
| Returns smallest valid key length. More...
virtual size_t | MaxKeyLength () const
| Returns largest valid key length. More...
virtual size_t | DefaultKeyLength () const
| Returns default key length. More...
virtual size_t | GetValidKeyLength (size_t keylength) const
| Returns a valid key length for the algorithm. More...
virtual IV_Requirement | IVRequirement () const
| Minimal requirement for secure IVs. More...
virtual unsigned int | IVSize () const
| Returns length of the IV accepted by this object. More...
virtual unsigned int | OptimalBlockSize () const
| Provides the input block size most efficient for this hash. More...
virtual unsigned int | OptimalDataAlignment () const
| Provides input and output data alignment for optimal performance. More...
virtual void | Update (const byte *input, size_t length)
| Updates a hash with additional input. More...
virtual void | TruncatedFinal (byte *digest, size_t digestSize)
| Computes the hash of the current message. More...
Public Member Functions inherited from SimpleKeyingInterface
virtual bool | IsValidKeyLength (size_t keylength) const
| Returns whether keylength is a valid key length. More...
virtual void | SetKey (const byte *key, size_t length, const NameValuePairs &params=g_nullNameValuePairs)
| Sets or reset the key of this object. More...
void | SetKeyWithRounds (const byte *key, size_t length, int rounds)
| Sets or reset the key of this object. More...
void | SetKeyWithIV (const byte *key, size_t length, const byte *iv, size_t ivLength)
| Sets or reset the key of this object. More...
void | SetKeyWithIV (const byte *key, size_t length, const byte *iv)
| Sets or reset the key of this object. More...
bool | IsResynchronizable () const
| Determines if the object can be resynchronized. More...
bool | CanUseRandomIVs () const
| Determines if the object can use random IVs. More...
bool | CanUsePredictableIVs () const
| Determines if the object can use random but possibly predictable IVs. More...
bool | CanUseStructuredIVs () const
| Determines if the object can use structured IVs. More...
unsigned int | DefaultIVLength () const
| Provides the default size of an IV. More...
virtual unsigned int | MinIVLength () const
| Provides the minimum size of an IV. More...
virtual unsigned int | MaxIVLength () const
| Provides the maximum size of an IV. More...
virtual void | Resynchronize (const byte *iv, int ivLength=-1)
| Resynchronize with an IV. More...
virtual void | GetNextIV (RandomNumberGenerator &rng, byte *iv)
| Retrieves a secure IV for the next message. More...
Public Member Functions inherited from HashTransformation
HashTransformation & | Ref ()
| Provides a reference to this object. More...
virtual byte * | CreateUpdateSpace (size_t &size)
| Request space which can be written into by the caller. More...
virtual void | Final (byte *digest)
| Computes the hash of the current message. More...
unsigned int | TagSize () const
| Provides the tag size of the hash. More...
virtual unsigned int | BlockSize () const
| Provides the block size of the compression function. More...
virtual void | CalculateDigest (byte *digest, const byte *input, size_t length)
| Updates the hash with additional input and computes the hash of the current message. More...
virtual bool | Verify (const byte *digest)
| Verifies the hash of the current message. More...
virtual bool | VerifyDigest (const byte *digest, const byte *input, size_t length)
| Updates the hash with additional input and verifies the hash of the current message. More...
virtual void | CalculateTruncatedDigest (byte *digest, size_t digestSize, const byte *input, size_t length)
| Updates the hash with additional input and computes the hash of the current message. More...
virtual bool | TruncatedVerify (const byte *digest, size_t digestLength)
| Verifies the hash of the current message. More...
virtual bool | VerifyTruncatedDigest (const byte *digest, size_t digestLength, const byte *input, size_t length)
| Updates the hash with additional input and verifies the hash of the current message. More...
Public Member Functions inherited from Algorithm
| Algorithm (bool checkSelfTestStatus=true)
| Interface for all crypto algorithms. More...
virtual std::string | AlgorithmName () const
| Provides the name of this algorithm. More...
virtual std::string | AlgorithmProvider () const
| Retrieve the provider of this algorithm. More...
Public Member Functions inherited from Clonable
virtual Clonable * | Clone () const
| Copies this object. More...

## Static Public Member Functions
static std::string | StaticAlgorithmName ()
Static Public Member Functions inherited from SipHash_Info< T_128bit >
static const char * | StaticAlgorithmName ()
Static Public Member Functions inherited from FixedKeyLength< 16 >
static size_t | StaticGetValidKeyLength (size_t keylength)
| The default key length for the algorithm provided by a static function. More...

## Additional Inherited Members
Public Types inherited from SimpleKeyingInterface
enum | IV_Requirement { UNIQUE_IV = 0 , RANDOM_IV , UNPREDICTABLE_RANDOM_IV , INTERNALLY_GENERATED_IV , NOT_RESYNCHRONIZABLE }
| Secure IVs requirements as enumerated values. More...
Static Public Attributes inherited from SipHash_Info< T_128bit >
static const int | DIGESTSIZE = (T_128bit ? 16 : 8)
Static Public Attributes inherited from FixedKeyLength< 16 >
static const int | KEYLENGTH
| The default key length used by the algorithm provided as a constant. More...
static const int | MIN_KEYLENGTH
| The minimum key length used by the algorithm provided as a constant. More...
static const int | MAX_KEYLENGTH
| The maximum key length used by the algorithm provided as a constant. More...
static const int | DEFAULT_KEYLENGTH
| The default key length used by the algorithm provided as a constant. More...
static const int | IV_REQUIREMENT
| The default IV requirements for the algorithm provided as a constant. More...
static const int | IV_LENGTH
| The default IV length used by the algorithm provided as a constant. More...

## Detailed Description

### template<unsigned int C, unsigned int D, bool T_128bit>
class SipHash_Base< C, D, T_128bit >

SipHash message authentication code base class.

Template Parameters

  C | the number of compression rounds
  D | the number of finalization rounds
  T_128bit | flag indicating 128-bit (true) versus 64-bit (false) digest size

Definition at line 51 of file siphash.h.

## Member Function Documentation

## ◆ DigestSize()

template<unsigned int C, unsigned int D, bool T_128bit>

virtual unsigned int SipHash_Base< C, D, T_128bit >::DigestSize | ( |  | ) | const
| inline virtual

Provides the digest size of the hash.

Returns
  the digest size of the hash.

Implements HashTransformation.

Definition at line 62 of file siphash.h.

## ◆ MinKeyLength()

template<unsigned int C, unsigned int D, bool T_128bit>

virtual size_t SipHash_Base< C, D, T_128bit >::MinKeyLength | ( |  | ) | const
| inline virtual

Returns smallest valid key length.

Returns
  the minimum key length, in bytes

Implements SimpleKeyingInterface.

Definition at line 64 of file siphash.h.

## ◆ MaxKeyLength()

template<unsigned int C, unsigned int D, bool T_128bit>

virtual size_t SipHash_Base< C, D, T_128bit >::MaxKeyLength | ( |  | ) | const
| inline virtual

Returns largest valid key length.

Returns
  the maximum key length, in bytes

Implements SimpleKeyingInterface.

Definition at line 66 of file siphash.h.

## ◆ DefaultKeyLength()

template<unsigned int C, unsigned int D, bool T_128bit>

virtual size_t SipHash_Base< C, D, T_128bit >::DefaultKeyLength | ( |  | ) | const
| inline virtual

Returns default key length.

Returns
  the default key length, in bytes

Implements SimpleKeyingInterface.

Definition at line 68 of file siphash.h.

## ◆ GetValidKeyLength()

template<unsigned int C, unsigned int D, bool T_128bit>

virtual size_t SipHash_Base< C, D, T_128bit >::GetValidKeyLength | ( | size_t | keylength | ) | const
| inline virtual

Returns a valid key length for the algorithm.

Parameters

  keylength | the size of the key, in bytes

Returns
  the valid key length, in bytes

keylength is provided in bytes, not bits. If keylength is less than MIN_KEYLENGTH, then the function returns MIN_KEYLENGTH. If keylength is greater than MAX_KEYLENGTH, then the function returns MAX_KEYLENGTH. if If keylength is a multiple of KEYLENGTH_MULTIPLE, then keylength is returned. Otherwise, the function returns a lower multiple of KEYLENGTH_MULTIPLE.

Implements SimpleKeyingInterface.

Definition at line 70 of file siphash.h.

## ◆ IVRequirement()

template<unsigned int C, unsigned int D, bool T_128bit>

virtual IV_Requirement SipHash_Base< C, D, T_128bit >::IVRequirement | ( |  | ) | const
| inline virtual

Minimal requirement for secure IVs.

Returns
  the secure IV requirement of the algorithm

Implements SimpleKeyingInterface.

Definition at line 72 of file siphash.h.

## ◆ IVSize()

template<unsigned int C, unsigned int D, bool T_128bit>

virtual unsigned int SipHash_Base< C, D, T_128bit >::IVSize | ( |  | ) | const
| inline virtual

Returns length of the IV accepted by this object.

Returns
  the size of an IV, in bytes

Exceptions

  NotImplemented() | if the object does not support resynchronization

The default implementation throws NotImplemented

Reimplemented from SimpleKeyingInterface.

Definition at line 74 of file siphash.h.

## ◆ OptimalBlockSize()

template<unsigned int C, unsigned int D, bool T_128bit>

virtual unsigned int SipHash_Base< C, D, T_128bit >::OptimalBlockSize | ( |  | ) | const
| inline virtual

Provides the input block size most efficient for this hash.

Returns
  The input block size that is most efficient for the cipher

The base class implementation returns MandatoryBlockSize().

Optimal input length is `n * OptimalBlockSize() - GetOptimalBlockSizeUsed()` for any `n > 0`.

Reimplemented from HashTransformation.

Definition at line 76 of file siphash.h.

## ◆ OptimalDataAlignment()

template<unsigned int C, unsigned int D, bool T_128bit>

virtual unsigned int SipHash_Base< C, D, T_128bit >::OptimalDataAlignment | ( |  | ) | const
| inline virtual

Provides input and output data alignment for optimal performance.

Returns
  the input data alignment that provides optimal performance

See also
  GetAlignment() and OptimalBlockSize()

Reimplemented from HashTransformation.

Definition at line 78 of file siphash.h.

## ◆ Update()

template<unsigned int C, unsigned int D, bool T_128bit>

void SipHash_Base< C, D, T_128bit >::Update | ( | const byte * | input,
|  | size_t | length
| ) |  |
| virtual

Updates a hash with additional input.

Parameters

  input | the additional input as a buffer
  length | the size of the buffer, in bytes

Implements HashTransformation.

Definition at line 157 of file siphash.h.

## ◆ TruncatedFinal()

template<unsigned int C, unsigned int D, bool T_128bit>

void SipHash_Base< C, D, T_128bit >::TruncatedFinal | ( | byte * | digest,
|  | size_t | digestSize
| ) |  |
| virtual

Computes the hash of the current message.

Parameters

  digest | a pointer to the buffer to receive the hash
  digestSize | the size of the truncated digest, in bytes

TruncatedFinal() calls Final() and then copies digestSize bytes to digest. The hash is restarted the hash for the next message.

Precondition
  `COUNTOF(digest) <= DigestSize()` or `COUNTOF(digest) <= HASH::DIGESTSIZE` ensures the output byte buffer is a valid size.

Implements HashTransformation.

Definition at line 206 of file siphash.h.

The documentation for this class was generated from the following file:

- siphash.h